给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。
示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum
主要思路,判断target - nums[i] 的结果是否在nums中存在。第一次遍历用一个HashMap以数字作为Key,索引作为value,将给定的nums存入HashMap中,第二次遍历每一个数的同时判断target - 当前数是否在HashMap中,若存在且index不等于当前的i则返回new int[]{index, i};
代码实现:
class Solution {
public int[] twoSum(int[] nums, int target) {
HashMap<Integer, Integer> map = new HashMap<>();
//把数字作为key, 下标索引作为value
for (int i = 0; i < nums.length; i++){
map.put(nums[i], i);
}
for (int i = 0; i < nums.length; i++){
int x = target - nums[i];
Integer index;
//如果target-当前数的差值在hashmap中
if(null != (index = map.get(x)) && index != i){
return new int[]{index, i};
}
}
return null;
}
}